use ruby style, support interactive shell
[errhandle.git] / err
diff --git a/err b/err
index 5b501ce44cb7bf8b24c01fb1718850e709ee1838..f6a7042eb0f5b0dd644b4829b881cc6aee92a999 100644 (file)
--- a/err
+++ b/err
 # limitations under the License.
 
 
-
 # Commentary: Bash stack trace and error handling functions. This file
 # is meant to be sourced. It loads some functions which you may want to
 # call manually (see the comments at the start of each one), and then
 # runs err-catch. See the README file for a slightly longer explanation.
 
-err-allow() {
-  # help: turn off exit and stack trace on error. undoes err-catch
-  set +E +o pipefail; trap ERR
-}
-err-bash-trace() {
-  # help: print stack trace
-  #
-  # Note: It does not show function args unless you first run:
-  # shopt -s extdebug
-  # err-catch runs this for you.
 
-  local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
+#######################################
+# Print stack trace
+#
+# usage: err-bash-trace [MESSAGE]
+#
+# This function is called by the other functions which print stack
+# traces.
+#
+# It does not show function args unless you first run:
+# shopt -s extdebug
+# which err-catch & err-print do for you.
+#
+# MESSAGE       Message to print just before the stack trace.
+#
+# _frame_start  Optional variable to set before calling. The frame to
+#               start printing on. default=1. Useful when printing from
+#               an ERR trap function to avoid printing that function.
+#######################################
+err-bash-trace() {
+  local -i argc_index=0 frame i start=${_frame_start:-1}
   local source
-  local extdebug=false
-  if [[ $(shopt -p extdebug) == *-s* ]]; then
-    extdebug=true
+  if [[ $1 ]]; then
+    printf "%s\n" "$1"
   fi
-  for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
+  for ((frame=0; frame < ${#FUNCNAME[@]}; frame++)); do
     argc=${BASH_ARGC[frame]}
     argc_index+=$argc
     ((frame < start)) && continue
     if (( ${#BASH_SOURCE[@]} > 1 )); then
-      source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
+      source="${BASH_SOURCE[frame]}:${BASH_LINENO[frame-1]}:"
     fi
-    indent=$((frame-start+1))
-    indent=$((indent < max_indent ? indent : max_indent))
-    printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
-    if $extdebug; then
+    printf "  from %sin \`%s" "$source" "${FUNCNAME[frame]}"
+    if shopt extdebug >/dev/null; then
       for ((i=argc_index-1; i >= argc_index-argc; i--)); do
         printf " %s" "${BASH_ARGV[i]}"
       done
     fi
     echo \'
   done
+  return 0
 }
-err-catch() {
-  # help: print stack trace and exit on error.
-  #
-  # Set "${_errcatch_cleanup[@]}" to set a command which will run before exiting.
-  # This function depends on err-bash-trace.
 
+#######################################
+# On error print stack trace and exit
+#
+# Globals:
+#   ${_errcatch_cleanup[@]}  Optional command & args that will run before exiting
+#######################################
+err-catch() {
   set -E; shopt -s extdebug
   _err-trap() {
     err=$?
     exec >&2
     set +x
-    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
-    # err trap does not work within an error trap, the following line:
-    err-bash-trace 2; set -e
-    "${_errcatch_cleanup[@]}"
-    echo "$0: exiting with code $err"
+    local msg="${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
+    if (( ${#FUNCNAME[@]} > 2 )); then
+      local _frame_start=2
+      err-bash-trace "$msg"
+    else
+      echo "$msg"
+    fi
+    set -e # err trap does not work within an error trap
+    # note :-: makes this compatible with set -u, assigns : if unset, but shellcheck
+    # doesn't understand that.
+    # shellcheck disable=SC2154
+    "${_errcatch_cleanup[@]:-:}"
+    echo "$0: exiting with status $err"
     exit $err
   }
   trap _err-trap ERR
   set -o pipefail
 }
-err-exit() {
-  # usage: err-exit [EXIT_CODE] [MESSAGE]
-  # help: exit and print stack trace.
+
+
+#######################################
+# For interactive shells: on error, print stack trace and return
+#
+# Globals:
+#   _err_func_last  Used internally.
+#   _err_catch_err  Used internally.
+#   _err_catch_i    Used internally.
+#
+# misc: All shellcheck disables for this function are false positives.
+#######################################
+# shellcheck disable=SC2120
+err-catch-interactive() {
+  # shellcheck disable=SC2034
+  declare -i _err_func_last=0
+  set -E; shopt -s extdebug
+  # shellcheck disable=SC2154
+  trap '_err_catch_err=$? _trap_bc="$BASH_COMMAND"
+  if (( ${#FUNCNAME[@]} > _err_func_last )); then
+    echo ERR: \`$_trap_bc'"\'"' returned $_err_catch_err
+  fi
+  _err_func_last=${#FUNCNAME[@]}
+  if (( _err_func_last )); then
+    printf "  from %s:%s:in \`%s" "${BASH_SOURCE[0]}" "$(declare -F "${FUNCNAME[0]}"|awk "{print \$2}")" "${FUNCNAME[0]}"
+    if shopt extdebug >/dev/null; then
+      for ((_err_catch_i=${BASH_ARGC[0]}-1; _err_catch_i >= 0; _err_catch_i--)); do
+        printf " %s" "${BASH_ARGV[_err_catch_i]}"
+      done
+    fi
+    echo '"\'"'
+    return $_err_catch_err
+  fi' ERR
+  set -o pipefail
+}
+
+
+#######################################
+# Undoes err-catch. turns off exit and stack trace on error.
+#######################################
+err-allow() {
+  set +E +o pipefail; trap ERR
+}
+
+#######################################
+# On error, print stack trace
+#######################################
+err-print() {
+  # help: on errors: print stack trace
   #
-  # Use this instead of the exit command to be more informative. default
-  # EXIT_CODE is 1. If only one of EXIT_CODE and MESSAGE is given,
-  # we consider it to be an exit code if it is a number.
   # This function depends on err-bash-trace.
 
+  set -E; shopt -s extdebug
+  _err-trap() {
+    err=$?
+    exec >&2
+    set +x
+    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
+    err-bash-trace 2
+  }
+  trap _err-trap ERR
+  set -o pipefail
+}
+
+
+#######################################
+# Print stack trace and exit
+#
+# Use this instead of the exit command to be more informative.
+#
+# usage: err-exit [EXIT_CODE] [MESSAGE]
+#
+# EXIT_CODE  Default is 1.
+# MESSAGE    Print MESSAGE to stderr. If only one of EXIT_CODE
+#            and MESSAGE is given, we consider it to be an
+#            exit code if it is a number.
+#######################################
+err-exit() {
   exec >&2
   code=1
-  if [[ $* ]]; then
+  if [[ "$*" ]]; then
     if [[ ${1/[^0-9]/} == "$1" ]]; then
       code=$1
       if [[ $2 ]]; then
-        printf "%s\n" "$2"
+        printf '%s\n' "$2" >&2
       fi
     else
-      printf "%s\n" "$0: $1"
+      printf '%s\n' "$0: $1" >&2
     fi
   fi
   echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
@@ -102,4 +187,10 @@ err-exit() {
   echo "$0: exiting with code $code"
   exit $err
 }
-err-catch
+
+# We want this more often than not, so run it now.
+if [[ $- == *i* ]]; then
+  err-catch-interactive
+else
+  err-catch
+fi